/**
 * JORM: an implementation of a generic mapping system for persistent Java
 *       objects. Two mapping are supported: to RDBMS and to binary files.
 * Copyright (C) 2001-2003 France Telecom R&D - INRIA
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: jorm-team@objectweb.org
 *
 */

package org.objectweb.jorm.mapper.rdb.generator;

import org.apache.velocity.context.Context;
import org.objectweb.jorm.generator.api.MOP;
import org.objectweb.jorm.generator.lib.CommonGenerator;
import org.objectweb.jorm.api.PException;
import org.objectweb.jorm.metainfo.api.Class;
import org.objectweb.util.monolog.api.Logger;

import java.util.HashMap;

/**
 * This class implements the BindingMOP interface in order to specialize the
 * generation of the PBinding for the relationnal database spport.
 * @author	Sebastien Chassande-Barrioz
 */
public class RdbBindingMOP extends RdbCommonHelper implements MOP {

	public RdbBindingMOP(HashMap mapping2geninfos, Logger logger) {
		super(mapping2geninfos, logger);
	}

	public void initContext(Context ctx, Class clazz,
							String projectName,
							String mapperName) throws PException {
		ctx.put("adapter", getRdbAdapter(mapperName));
		ctx.put("G", "\"");
		ctx.put("genInfos", getRdbGenInfos(clazz, projectName, mapperName));
	}

	public String[] getTemplateLibraries() {
		String[] libs = {CommonGenerator.MAPPER_TEMPLATE_DIR + "rdb/generator/RdbBinding.vm"};
		return libs;
	}
}
